from escritora import PONTUACAO
import solucao as escritora

"""
  OBSERVAR QUE O TRAVESSÃO (—) USADO NO EP É DIFERENTE DO "SINAL DE MENOS (-)"

  copiar caractere dos exemplos :)
"""


'''
  1. Função insira_espacos

     recebe string (frase)
     devolve frase com espaços delimitando sinais de pontuação

     insira_espacos('Vou indo. Vou rindo.')
     'Vou indo .  Vou rindo . '.split() -> ['Palavra', '?']

     Olá, você
     Olá ,  você


'''

"""
ABORDAGEM COM str.replace()
"""

# primeira_opiniao = 'eu gosto da cor azul'
# mudanca_de_opiniao = primeira_opiniao.replace('gosto', 'não gosto')
# print('antes do replace')
# print(primeira_opiniao)
# print('depois do replace')
# print(mudanca_de_opiniao)

""" 
ABORDAGEM CARACTERE A CARACTERE
examinar caractere a caractere
trocar sinal de exclamação pela palavra uhul
"""


# frase = 'Olá, eu ja consegui fazer o ep12!'

# tamanho_da_frase = len(frase)
# indice = 0
# nova_frase = ''
# while indice < tamanho_da_frase:
#   caractere = frase[indice]
#   if caractere == '!':
#     nova_frase += 'uhul'
#   else:
#     nova_frase += caractere
#   indice+=1
# print(nova_frase)


########################################################################


"""
  2. função dicio_sucessores(list) -> dict

  criar um dicionario em que cada chave é um elemento da lista. O valor de cada chave é uma lista contendo
  todas as palavras que estão após cada ocorrência da chave na lista.
"""

frase = 'Vou indo. Vou rindo.'

frase_espacos = escritora.insira_espacos(frase) # -> Vou indo .  Vou rindo .

lst_frase = frase_espacos.split() # -> split quebra a string por espaços, retornando uma lista com as "partes" da frase.
# -> ['Vou', 'indo', '.', 'Vou', 'rindo', '.']
"""
chaves = {'Vou', 'indo', '.', 'rindo'}
valores por chave
Vou: ['indo', 'rindo']
"""

# verificar se é o ultimo item
# indice = i+1
# if indice == len(lst):
#   indice = 0
# dicio[chave] = lst[indice]

# dicio['Vou'] = ['rindo']

# if chave not in dicio:
#   dicio[chave] = []
# dicio[chave] += [item_atual]

dicio_sucessores_frase = escritora.dicio_sucessores(lst_frase)

"""

cada linha é uma entrada do dicionário gerado (lembrando que a estrutura do dicionário é str -> lista)

{
  'Vou': ['indo', 'rindo'],
  
  'indo': ['.'],
  
  '.': ['Vou', 'Vou'],
  
  'rindo': ['.']
  }

NAO SE IMPORTAR COM A ORDEM QUE O DICIONARIO ESTA SENDO IMPRESSO;
lembrar que o último caractere será "sucedido" pelo primeiro.
"""

"""
 3. Função gere_frase(str, dicio) -> str

 a partir da palavra inicial, ir sorteando sucessores até que encontre um sinal de pontuação final.

 ler bem a especificação da função.

"""

# dicio[chave] => lista
# item_atual = random.choice(dicio[chave])
# nova_frase += item_atual

# Estamos cansados.
# [Estamos, cansados, .]
# nova_frase = p_inicial
# item_atual = p_inicial
# for com as condições... sortear a proxima palavra <- item_atual
# if item_atual not in PONTUACAO:
#   nova_frase += ' '
# nova_frase += item_atual

# frase gerada da funcao gere_frase
"Estamos cansados ." # -> errado
" Estamos cansados." # -> errado
"Estamos cansados." # -> certo

# Lá vou eu e lá vai você -> o dicionário terá dois "lás" - um "Lá" e outro "lá"
# não é case sensitive


'''''
 uso do ep como um todo:
'''''
frase = "Todo problema tem a sua solução - ou tem o seu soluço."
frase_espacos = escritora.insira_espacos(frase)
lst_frase = frase_espacos.split()
dicio_frase = escritora.dicio_sucessores(lst_frase)
print(escritora.gere_frase('problema', dicio_frase))